*****************
*****************
**
**  Purpose:  Calculates the number of work days (M-F) between two dates
**
**   Syntax:  weekdays( <stdate>, <endate> )
**
**   Parameters:
**
**      Name        T Description
**        
**      stdate      D Starting date
**      endate      D Ending date
**
**  Returns:  Number of week days from <stdate> to <endate>
**
**  Example:  weekdays( m->st, m->ed )  
**            ****** Returns 10 if st = 4/1/90 and ed = 4/15/90
**            ****** Returns 12 if st = 4/1/90 and ed = 4/17/90
**
**    Files:  None.
**
** Overview:  Very handy function for payroll systems.
**
**    Notes:  
**
**    Class:  Date function
**
** See Also:  bom() eom()
**
*****************
*****************
function weekdays
parameter stdate, endate
private retnum, pc, days, weeks
pc = pcount()
if m->pc < 2
  return 0
endif
if m->stdate > m->endate
  return 0
elseif m->stdate = m->endate
  if dow( m->stdate ) = 1 .or. dow( m->stdate ) = 7
    return 0
  else
    return 1
  endif
endif

if dow( m->stdate ) = 1 && Sunday
  stdate = m->stdate + 1
elseif dow( m->stdate ) = 7 && Saturday
  stdate = m->stdate + 2
endif

if dow( m->endate ) = 1 && Sunday
  endate = m->endate - 2
elseif dow( m->endate ) = 7 && Saturday
  endate = m->endate - 1
endif

days = m->endate - m->stdate + 1
adj = days % 7
if dow( m->endate ) < dow( m->stdate )
  adj = m->adj - 2
endif
weeks = int( m->days / 7 )
retnum = m->weeks * 5 + m->adj
return m->retnum

